from walker.commands.command import Command
from walker.config import Config
from walker.repl_state import ReplState
from walker.utils import lines_to_tabular, log

class ShowParams(Command):
    COMMAND = 'show params'

    # the singleton pattern
    def __new__(cls, *args, **kwargs):
        if not hasattr(cls, 'instance'): cls.instance = super(ShowParams, cls).__new__(cls)

        return cls.instance

    def __init__(self, successor: Command=None):
        super().__init__(successor)

    def command(self):
        return ShowParams.COMMAND

    def run(self, cmd: str, state: ReplState):
        if not self.args(cmd):
            return super().run(cmd, state)

        lines = [f'{key} {Config().get(key, None)}' for key in Config().keys()]
        log(lines_to_tabular(lines))

        return lines

    def completion(self, state: ReplState):
        return super().completion(state)

    def help(self, _: ReplState):
        return f"{ShowParams.COMMAND}: show Kaqing parameters"